/*
 * reaction_time.c
 *
 *  Created on: 23/mar/2014
 *      Author: fb
 */


#include "../Inc/config.h"
#include "sys/alt_timestamp.h"
#include "altera_up_avalon_parallel_port.h"
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
/* ------------------------------------------------------------------------- */

/* delay */
//#define CYCLES_PER_MS 254 /* hand tuned to achieve around 1 ms resolution (code optimization OFF)*/
#define CYCLES_PER_MS 310 /* hand tuned to achieve around 1 ms resolution (code optimization OFF)*/
void Wait_ms(uint32_t time_ms) {
	int32_t i,j;
	for(j=0; j<time_ms; j++) {
		for(i=0; i<CYCLES_PER_MS; i++) {;}
	}
}
/* ------------------------------------------------------------------------- */


int main() {

// Define the macro PROFILE_WAIT_MS to compile the code for measuring the delay introduced by the Wait_ms() functions
// Otherwise the code for the reaction time program will be compiled
//#define PROFILE_WAIT_MS		1

#ifdef PROFILE_WAIT_MS
	uint32_t delay_ms, time, freq;
	freq = alt_timestamp_freq();
	printf("DE2 $ The Interval Timer clock frequency is %d Hz\n", freq);
	while(1) {
		printf("DE2 $ Type the delay value in ms\n");
		scanf("%u", &delay_ms);
		alt_timestamp_start();
		Wait_ms(delay_ms);
		time = alt_timestamp();
		printf("DE2 $ The function Wait_ms(%u) lasted %.1f ms\n", (unsigned int)delay_ms, (1000.0*time)/freq);
	}
#else
	alt_up_parallel_port_dev *key_dev, *leds_dev;
	uint32_t time[NUM_TESTS], freq;
	int iter, rand_mul;

	freq = alt_timestamp_freq();
	printf("DE2 $ The Interval Timer clock frequency is %d Hz\n", freq);

	key_dev = alt_up_parallel_port_open_dev(KEY_DEV_NAME);
	leds_dev = alt_up_parallel_port_open_dev(LEDS_DEV_NAME);

	printf("DE2 $ Welcome to the reaction time test!\n");

	alt_up_parallel_port_write_data(leds_dev, LEDS_ALL_ON);


	while(1){

		printf("DE2 $ Press KEY%d to start\n", KEY_POS);
		printf("DE2 $ Wait until a single led turns on and then press KEY%d as fast as you can\n", KEY_POS);
		/* Clear pushbutton edge register */
		alt_up_parallel_port_clear_edge_capture(key_dev);

		/* Wait until KEY_START is pressed */
		while(!(alt_up_parallel_port_read_edge_capture(key_dev) & (1<<KEY_POS))) {;}
		alt_up_parallel_port_write_data(leds_dev, LEDS_ALL_OFF);

		/* Repeat test */
		for (iter=0; iter<NUM_TESTS; iter++) {
			rand_mul = rand() % (WAIT_MAX_MS - WAIT_MIN_MS)/WAIT_RAND_MS;

			Wait_ms(WAIT_MIN_MS + WAIT_RAND_MS*rand_mul);


			alt_up_parallel_port_clear_edge_capture(key_dev); /* Clear pushbutton edge register */
			alt_up_parallel_port_write_data(leds_dev, LEDS_TEST_ON);

			alt_timestamp_start();

			/* Wait until KEY_START is pressed */
			while(!(alt_up_parallel_port_read_edge_capture(key_dev) & (1<<KEY_POS))) {;}
			time[iter] = alt_timestamp();
			alt_up_parallel_port_write_data(leds_dev, LEDS_ALL_OFF);
		}
		alt_up_parallel_port_write_data(leds_dev, LEDS_ALL_ON);

		/* display results on NiosII console */
		for (iter=0; iter<NUM_TESTS; iter++) {
			printf("DE2 $ Reaction time %u = %.1f ms\n", (unsigned int) iter, ((1000.0*time[iter]))/freq);
		}
	} //while
#endif
}
